<template>
  <div class="distribution-panel">
    <ob-table
      :columns="distColumns"
      :functionalPanel="true"
      :show-add-button="!(rule.titul.status === 'ACTIVE' || rule.titul.status === 'TERMINATED' || rule.titul.status === 'REMOVED')"
      :remote-opt="{
        method: getServices,
      }"
      :tableLayoutFixed="false"
      :isSmartPagination="false"
      @select="onSelect"
      @add="onAdd"
      data-qa="distTable"
      ref="obTableDistribution"
    >

      <template v-slot:extraFuncToPanel>
        <div class="table-filters">
          <div class="table-filter">
            <span>Группировать: </span>
            <ob-inline-select
              v-model="group"
              :items="groupFilters"
            />
          </div>
          <div>
            <ob-switcher
              labelRight="Скрывать неактивные направления"
              v-model="hideUnactive"
            />
          </div>
        </div>
      </template>


      <template v-slot:status="{ data }">
        <i class="icon checked" v-if="data.item.isReady"></i>
      </template>

      <template v-slot:actions="{ data }">
        <ob-menu-dropdown
          :items="[{ title: 'Настроить услугу', method: () => onAdd(data) }, {title: 'Удалить услугу', method: () => confirmDelete(data)}]"
          trigger="click"
          :class="rule.titul.status === 'ACTIVE' || rule.titul.status === 'TERMINATED' || rule.titul.status === 'REMOVED' ? 'disabled' : ''"
        >
        </ob-menu-dropdown>
      </template>

      <template slot="noneContent">
        <div class="no-content">
          <p>
            Здесь вы сможете распределять рейсы для ваших исполнителей. Для
            этого добавьте хотя бы одну услугу.
          </p>
          <span @click="onAdd" :class="{disabled: rule.titul.status === 'ACTIVE' || rule.titul.status === 'TERMINATED' || rule.titul.status === 'REMOVED'}">Добавить услугу</span>
        </div>
      </template>
    </ob-table>

    <ob-modal
      ref="serviceModal"
      title="Услуга"
      titleSecond="Добавление "
      :is-show-controls="false"
      size="large"
    >
      <ServiceModal @submitted="onSubmittedForm" :data-source="selectedService" :contractors="policyContractors" />
    </ob-modal>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';
import api from "@/api";
import ObTable from "common-components/src/obComponents/obTable";
import ObModal from "common-components/src/obComponents/obModal";
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown';
import ObInlineSelect from 'common-components/src/obComponents/obInlineSelect';
import ObSwitcher from 'common-components/src/obComponents/obSwitcher';
import ServiceModal from "./ServiceModal";
export default {
  name: "distributonTab",

  components: {
    ObTable,
    ObModal,
    ObMenuDropdown,
    ObInlineSelect,
    ObSwitcher,
    ServiceModal,
  },

  data() {
    return {
      policyContractors: [],
      groupFilters: [
        {
          title: 'По типу услуги',
          uuid: 'type'
        },
        {
          title: 'По типу ресурса',
          uuid: 'resource'
        },
        {
          title: 'По единице измерения',
          uuid: 'unit'
        }
      ],
      group: 'type',
      hideUnactive: false,
      selectedService: '',
      distColumns: [
        {
          title: "Услуга",
          key: "serviceTypeTitle",
        },
        {
          title: "ресурс",
          key: "resourceTitle",
        },
        {
          title: "единица измерения",
          key: "serviceUnitTitle",
        },
        {
          title: "готово",
          key: "isReady",
          slotName: "status",
        },
        {
          title: "кол-во исполнителей",
          key: "participantCount",
          sortDisable: true
        },
        {
          title: '',
          slotName: 'actions',
          action: true,
          isToggleDisabled: true
        }
      ],
    };
  },

  computed: {
    ...mapGetters({
      rule: 'tms/rule'
    })
  },

  created() {
    if (!this.rule.uuid.length) {
      this.$router.push('/tms');
    }
  },

  methods: {
    ...mapActions({
      setRuleServices: 'tms/setRuleServices'
    }),

    async getPolicyContractors() {
       try {
        this.policyContractors = await api.tms.getPolicyContractors();
      } catch (e) {
        console.error(e);
      }
    },

    async getServiceInfo(uuid) {
      try {
        const res = await api.tms.getServiceInfo(uuid);
        return res;
      } catch (e) {
        console.error(e);
      }
    },

    async getServices({page, size, sort="createdAt,DESC", query}) {
      const altSort = sort?.split(',');
      try {
        const services = await api.tms.getPolicyServices(this.rule.uuid, {page, size, sort: altSort[0], direction: altSort[1].toUpperCase(), query});
        this.setRuleServices(services.content);
        return services;
      } catch (e) {
        console.error(e);
      }
    },

    onSelect(data) {
      this.$router.push({name: 'tms_directions', params: {service: data.uuid}})
    },

    async onAdd(data) {
      try {
        this.getPolicyContractors();
        if (data.item) {
          const res = await this.getServiceInfo(data.item.uuid);
          this.selectedService = {
            uuid: res.uuid,
            contractors: res.participants.map(item => item.uuid),
            activeTransportType: res.serviceUuid
          };
        } else {
          this.selectedService = {
            uuid: '',
            contractors: [],
            activeTransportType: ''
          };
        }
        this.$refs.serviceModal.open();
      } catch (e) {
        console.error(e);
      }
    },

    confirmDelete() {
      console.log('delete');
    },

    async onSubmittedForm($event) {
      await this.getServices({page:0, size:20, sort:"createdAt,DESC", query:''});

      this.$refs.serviceModal.close();
      this.$router.push({name: 'tms_directions', params: {service: $event}})
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.distribution-panel {
  height: 100%;
}

.ob-table-inner {
  margin: -25px;
}

.no-content {
  padding: 20px;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;

  p {
    @include font-mixin(24px, 40px, 400, $color-grey-span);
  }

  span {
    margin-top: 20px;
    @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);
    text-decoration: none;
    cursor: pointer;

    &.disabled {
      pointer-events: none;
      opacity: 0.5;
    }
  }
}

.checked {
  color: $Green-700;
}

.table-filters {
  display: flex;
  align-items: center;
  width: 100%;
}

.table-filter {
  background: $blue-150;
  border-radius: 19px;
  padding: 5px 9px;
  font-size: 14px;
  line-height: 18px;
  letter-spacing: 0.2px;
  color: $shale-gray;

  &:nth-child(1) {
    margin-right: 12px;
  }

  &:nth-child(2) {
    margin-right: 22px;
  }
}

::v-deep {
  table {
    min-width: auto;
  }

  th:last-child {
    pointer-events: none;
  }

  th:last-child .td-container,
  td:last-child .td-container {
    justify-content: flex-end;
  }

  th:nth-child(4) .td-container,
  td:nth-child(4) .td-container {
    justify-content: center;
  }
}

.disabled {
  pointer-events: none;
}
</style>
